import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class FlappyBird here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlappyBird extends Actor {
    double dy = -7.2;
    double g = 0.5;
    double BOOST_SPEED = -5.5;
    boolean isPaused = true;
    int score = +5;
    int count = 0;
    CoinCount coinCount = null;
    
    Score scoreCount = null;
    GreenfootSound music = new GreenfootSound("DragonRider.mp3");
    GreenfootSound aww = new GreenfootSound("Aww.mp3");
    GreenfootSound punch = new GreenfootSound("Punch.mp3");
    GreenfootSound ding = new GreenfootSound("Coin.mp3");
    /**
     * Act - do whatever the FlappyBird wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {

        playMusic();
        getCoin();
        die();
        move();
        getEaten();
        
        pause();

    }    

    public void move() {
        setLocation (getX(), (int) (getY() + dy));
        dy = dy + g;
        if (Greenfoot.isKeyDown("up") == true) { 
            dy = BOOST_SPEED;
        }
        if (dy > 5) {
            setRotation(30);
        } else if (dy < 0){
            setRotation(-30);
        } else {
            setRotation(0);
        }
    }

    private void gameOver() {
        punch.play();
        GameOver gameOver = new GameOver();
        getWorld().addObject(gameOver, getWorld().getWidth()/2, getWorld().getHeight()/2);
        music.stop();
        aww.play();
        Greenfoot.stop();
    }

    public void die(){
        if (getOneIntersectingObject(BottomPipe.class) != null) {
            gameOver();

        }
        if (getOneIntersectingObject(TopPipe.class) != null) {
            gameOver();
        }
        if (getOneIntersectingObject(Ground.class) != null) {
            gameOver();
        }
        if (getY() >= getWorld().getHeight() ) {
            gameOver();
        }
    }

    public void playMusic() {
        music.play();
    }

    public void pause() {
        if (Greenfoot.isKeyDown("p")) {
            music.stop();
            Greenfoot.stop();
        }
    }

    public void getCoin() {
        Actor coin;
        coin = getOneObjectAtOffset(0, 0, Coin.class);
        
        if (coin != null) {
            World world;
            world = getWorld();
            world.removeObject(coin);
            ding.play();
            //FlappyWorld flappyWorld = (FlappyWorld) world;
            //CoinCount coinCount = flappyWorld.getCoinCount();
            //count++;
            //coinCount.setCount(count);
        }
    }

    public void getEaten() {
        Actor seal;
        seal = getOneObjectAtOffset(0, 0, Seal.class);
        if (seal != null) {
            
            GameOver gameOver = new GameOver();
            getWorld().addObject(gameOver, getWorld().getWidth()/2, getWorld().getHeight()/2);
            getWorld().removeObject(this);
            music.stop();
            Greenfoot.playSound("yum.wav");
            aww.play();
            Greenfoot.stop();
        }
    }
}
